/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "playaudio.h"

typedef struct _audio_idx_map
{
    uint8 idx;
    uint8 music_data;
}audio_idx_map;

const audio_idx_map g_audio_map[]=
{
    {AUDIO_OPEN,0x01},
    {AUDIO_KEY_CLICK,0x02},
    {AUDIO_ALERT,0x03},
    {AUDIO_WARNING,0x04},
    {AUDIO_INVALID,AUDIO_INVALID}
};

#define MSO_MASK    (0x80) 
static inline void data_output(uint8 data)
{
    uint8 i= 0;
    
    for(i = 0; i < 8;i++){
        AUDIO_CLK_Write(0);
        if(data & MSO_MASK){
            AUDIO_DATA_Write(1);
        }else{
            AUDIO_DATA_Write(0);
        }
        CyDelayUs(60);
        data <<= 1;
        AUDIO_CLK_Write(1);
        CyDelayUs(60);
    }
}

static inline uint8 get_audio_data(uint8 idx)
{
    uint8 data = AUDIO_INVALID;
    uint8 i;
    for(i = 0;i < sizeof(g_audio_map)/sizeof(audio_idx_map);i++){
        if(idx == g_audio_map[i].idx){
            data = g_audio_map[i].music_data;
            break;
        }
    }
    return data;
}

void playback_audio(audio_index idx)
{
    while(AUDIO_BUSY_Read());
    playback_audio_overwrite(idx);
}

void playback_audio_overwrite(audio_index idx)
{
    //NOTE: The 6ms delay can be optimized, if it is necessary. if need optimize, it need to 
    //know the device alreay in active mode.
    AUDIO_CLK_Write(1);
    CyDelay(6);
    AUDIO_CLK_Write(0);
    CyDelayUs(100);
    data_output(get_audio_data(idx));
    AUDIO_CLK_Write(0);
    AUDIO_DATA_Write(0);
}

/* [] END OF FILE */
